Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.admin.tools.upgrade
Class UpgradeDriverManager

All Known Implementing Classes:
  UpgradeDriver

    public interface class UpgradeDriverManager

The management interface for a schema upgrade.

(Unpublished)

Field Summary
`static int` | `TASK_ANALYZE` The task value that indicates the upgrade driver is executing the `analyze` method.
`static int` | `TASK_NONE` The task value that indicates no upgrade driver task is being performed.
`static int` | `TASK_POSTUPGRADE` The task value that indicates the upgrade driver is executing the `postUpgrade` method.
`static int` | `TASK_PREUPGRADE` The task value that indicates the upgrade driver is executing the `preUpgrade` method.
`static int` | `TASK_ROLLBACK` The task value that indicates the upgrade driver is executing the `rollback` method.
`static int` | `TASK_UPGRADE` The task value that indicates the upgrade driver is executing the `upgrade` method.

Method Summary
`void` | `addUpgradeDriverListener(UpgradeDriverListener udl)` Adds an UpgradeDriverListener.
`boolean` | `analyze()` Starts or continues the analysis phase of a schema upgrade.
`void` | `dispose()` Disposes this UpgradeDriverManager.
`int` | `getCurrentTask()` Gets the current task being performed by the upgrade driver.
`UpgradeStatus` | `getMostRecentUpgrade()` Gets the most-recent schema upgrade performed or attempted.
`UpgradeStatus[]` | `getUpgradeHistory()` Gets the history of all schema upgrades performed or attempted, in chronological order.
`boolean` | `isDisposed()` Gets whether `dispose` has been called on this UpgradeDriverManager.
`boolean` | `postUpgrade()` Starts or continues the post-upgrade phase of a schema upgrade.
`boolean` | `preUpgrade()` Starts, continues, or repeats the pre-upgrade phase of a schema upgrade.
`void` | `removeUpgradeDriverListener(UpgradeDriverListener udl)` Removes an UpgradeDriverListener.
`boolean` | `rollback(boolean offline)` Starts or continues rolling back a schema upgrade.
`void` | `stop()` Requests the in-progress `analyze`, `preUpgrade`, `upgrade`, `postUpgrade`, or `rollback` to stop.
`java.lang.String` | `toStatusLabel(int status)` Gets a string representation of the specified status value.
`java.lang.String` | `toTaskLabel(int task)` Gets a string representation of the specified task value.
`boolean` | `upgrade(boolean offline)` Starts or continues the upgrade phase of a schema upgrade.

Field Detail

### TASK_NONE

    static final int TASK_NONE

  Description copied from interface: `UpgradeDriverManager`
  The task value that indicates no upgrade driver task is being performed.

  See Also:
    Constant Field Values
  (Unpublished)

### TASK_ANALYZE

    static final int TASK_ANALYZE

  Description copied from interface: `UpgradeDriverManager`
  The task value that indicates the upgrade driver is executing the `analyze` method.

  See Also:
    Constant Field Values
  (Unpublished)

### TASK_PREUPGRADE

    static final int TASK_PREUPGRADE

  Description copied from interface: `UpgradeDriverManager`
  The task value that indicates the upgrade driver is executing the `preUpgrade` method.

  See Also:
    Constant Field Values
  (Unpublished)

### TASK_UPGRADE

    static final int TASK_UPGRADE

  Description copied from interface: `UpgradeDriverManager`
  The task value that indicates the upgrade driver is executing the `upgrade` method.

  See Also:
    Constant Field Values
  (Unpublished)

### TASK_POSTUPGRADE

    static final int TASK_POSTUPGRADE

  Description copied from interface: `UpgradeDriverManager`
  The task value that indicates the upgrade driver is executing the `postUpgrade` method.

  See Also:
    Constant Field Values
  (Unpublished)

### TASK_ROLLBACK

    static final int TASK_ROLLBACK

  Description copied from interface: `UpgradeDriverManager`
  The task value that indicates the upgrade driver is executing the `rollback` method.

  See Also:
    Constant Field Values
  (Unpublished)

Method Detail

### addUpgradeDriverListener

    void addUpgradeDriverListener(UpgradeDriverListener udl)
                                  throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Adds an UpgradeDriverListener.

  Parameters:
    `udl` - the listener
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### removeUpgradeDriverListener

    void removeUpgradeDriverListener(UpgradeDriverListener udl)
                                     throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Removes an UpgradeDriverListener.

  Parameters:
    `udl` - the listener
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### analyze

    boolean analyze()
                    throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Starts or continues the analysis phase of a schema upgrade.

  An exception is thrown if `analyze`, `preUpgrade`, `upgrade`, `postUpgrade`, or `rollback` are underway in another thread.

  When the method is called, the `upgrade status` must be Initialized or Analyzing. Otherwise an exception is thrown.

  If the `analyze` method of an upgrade action in the schema upgrade throws an exception, it is logged and rethrown. The upgrade status is set to Analyzing.

  The method returns when the analysis phase is completed or `stopped`. If the analysis phase completes with no errors, the upgrade status is set to Analyzed and `true` is returned; otherwise the upgrade status is set to Analyzing and `false` is returned.

  Returns:
    whether the analysis phase completed with no errors
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### preUpgrade

    boolean preUpgrade()
                       throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Starts, continues, or repeats the pre-upgrade phase of a schema upgrade.

  An exception is thrown if `analyze`, `preUpgrade`, `upgrade`, `postUpgrade`, or `rollback` are underway in another thread.

  When the method is called, the `upgrade status` must be Analyzed, Pre-upgrading, or Pre-upgraded. Otherwise an exception is thrown.

  If the `preUpgrade` method of an upgrade action in the schema upgrade throws an exception, it is logged and rethrown. The upgrade status is set to Pre-upgrading.

  The method returns when the pre-upgrade phase is completed or `stopped`. If the pre-upgrade phase completes with no errors, the upgrade status is set to Pre-upgraded and `true` is returned; otherwise the upgrade status is set to Pre-upgrading and `false` is returned.

  Returns:
    whether the pre-upgrade phase completed with no errors
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### upgrade

    boolean upgrade(boolean offline)
                    throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Starts or continues the upgrade phase of a schema upgrade.

  An exception is thrown if `analyze`, `preUpgrade`, `upgrade`, `postUpgrade`, or `rollback` are underway in another thread.

  When the method is called, the `upgrade status` must be Pre-upgraded or Upgrading. Otherwise an exception is thrown.

  The upgrade phase must be performed with the repository offline (that is, with all nodes stopped). If the repository is not offline, as indicated by the `offline` argument, an exception is thrown.

  If the `upgrade` method of an upgrade action in the schema upgrade throws an exception, it is logged and rethrown. The upgrade status is set to Upgrading.

  The method returns when the upgrade phase is completed or `stopped`. If the upgrade phase completes with no errors, the upgrade status is set to Upgraded, the schema version is updated to the `target schema version`, and `true` is returned; otherwise the upgrade status is set to Upgrading and `false` is returned.

  Parameters:
    `offline` - whether the repository is offline (that is, whether all nodes are stopped)
  Returns:
    whether the upgrade phase completed with no errors
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### postUpgrade

    boolean postUpgrade()
                        throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Starts or continues the post-upgrade phase of a schema upgrade.

  An exception is thrown if `analyze`, `preUpgrade`, `upgrade`, `postUpgrade`, or `rollback` are underway in another thread.

  When the method is called, the `upgrade status` must be Upgraded or Post-upgrading. Otherwise an exception is thrown.

  If the `postUpgrade` method of an upgrade action in the schema upgrade throws an exception, it is logged and rethrown. The upgrade status is set to Post-upgrading.

  The method returns when the post-upgrade phase is completed or `stopped`. If the post-upgrade phase completes with no errors, the upgrade status is set to Completed and `true` is returned; otherwise the upgrade status is set to Post-upgrading and `false` is returned.

  Returns:
    whether the post-upgrade phase completed with no errors
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### rollback

    boolean rollback(boolean offline)
                     throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Starts or continues rolling back a schema upgrade.

  An exception is thrown if `analyze`, `preUpgrade`, `upgrade`, `postUpgrade`, or `rollback` are underway in another thread.

  When the method is called, the `upgrade status` must be Initialized, Analyzing, Analyzed, Pre-upgrading, Pre-upgraded, Upgrading, Upgraded, Post-upgrading, Completed, or Rolling-back. Otherwise an exception is thrown.

  If the upgrade status is Upgrading, Upgraded, Post-upgrading, or Completed, the rollback must be performed with the repository offline (that is, with all nodes stopped). If the repository is not offline, as indicated by the `offline` argument, an exception is thrown.

  If the `rollback` method of an upgrade action in the schema upgrade throws an exception, it is logged and rethrown. The upgrade status is set to Rolling-back.

  The method returns when the rollback is completed or `stopped`. If the rollback completes with no errors, the upgrade status is set to Rolled-back, the schema version is updated to the `source schema version`, and `true` is returned; otherwise the upgrade status is set to Rolling-back and `false` is returned.

  Parameters:
    `offline` - whether the repository is offline (that is, whether all nodes are stopped)
  Returns:
    whether the rollback completed with no errors
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCurrentTask

    int getCurrentTask()
                       throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Gets the current task being performed by the upgrade driver.

  The returned value is one of:

  - `TASK_NONE` if no task is being performed,
  - `TASK_ANALYZE` if executing the `analyze` method,
  - `TASK_PREUPGRADE` if executing the `preUpgrade` method,
  - `TASK_UPGRADE` if executing the `upgrade` method,
  - `TASK_POSTUPGRADE` if executing the `postUpgrade` method, or
  - `TASK_ROLLBACK` if executing the `rollback` method

  Returns:
    the current task
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### stop

    void stop()
              throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Requests the in-progress `analyze`, `preUpgrade`, `upgrade`, `postUpgrade`, or `rollback` to stop.

  If none of these methods are underway, a call to `stop` has no effect.

  Throws:
    `IfsException`
  (Unpublished)

### dispose

    void dispose()
                 throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Disposes this UpgradeDriverManager.

  After this method is called, all other methods on this interface (apart from `isDisposed`, but including `dispose`) will throw an exception.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isDisposed

    boolean isDisposed()
                       throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Gets whether `dispose` has been called on this UpgradeDriverManager.

  Returns:
    whether disposed
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getUpgradeHistory

    UpgradeStatus[] getUpgradeHistory()
                                      throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Gets the history of all schema upgrades performed or attempted, in chronological order.

  Returns:
    the schema upgrades
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getMostRecentUpgrade

    UpgradeStatus getMostRecentUpgrade()
                                       throws IfsException

  Description copied from interface: `UpgradeDriverManager`
  Gets the most-recent schema upgrade performed or attempted.

  If an schema upgrade is underway, this method will return that upgrade.

  Returns:
    the most-recent schema upgrade, or null if there is no previous schema upgrade
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### toTaskLabel

    java.lang.String toTaskLabel(int task)

  Description copied from interface: `UpgradeDriverManager`
  Gets a string representation of the specified task value.

  Parameters:
    `task` - the task; must be
    - `TASK_NONE`,
    - `TASK_ANALYZE`,
    - `TASK_PREUPGRADE`,
    - `TASK_UPGRADE`,
    - `TASK_POSTUPGRADE`, or
    - `TASK_ROLLBACK`
  Returns:
    a string representation

### toStatusLabel

    java.lang.String toStatusLabel(int status)

  Description copied from interface: `UpgradeDriverManager`
  Gets a string representation of the specified status value.

  Parameters:
    `status` - the status value; must be
    - `STATUS_INITIALIZED`,
    - `STATUS_ANALYZING`,
    - `STATUS_ANALYZED`,
    - `STATUS_PREUPGRADING`,
    - `STATUS_PREUPGRADED`,
    - `STATUS_UPGRADING`,
    - `STATUS_UPGRADED`,
    - `STATUS_POSTUPGRADING`,
    - `STATUS_COMPLETED`,
    - `STATUS_ROLLINGBACK`, or
    - `STATUS_ROLLEDBACK`
  Returns:
    a string representation
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD